import sys
import time
import pyfaspmgmt
import os

if not sys.argv[1:]:
  print "Please specify files to transfer"
  exit(-1);

session = pyfaspmgmt.FaspSend(
  "aspera",
  "demo.asperasoft.com",
  persistent=True,
  password="demoaspera",
  args = ['-P','33001', '-L', '.', '-l', '20M'  ] )

totalFiles=0
for fi in sys.argv[1:]:
  session.totalBytes += os.stat(fi).st_size 
  session.addFile(fi, "Upload/%s" % os.path.basename(fi))
  totalFiles+=1

while session.status() not in ("DONE", "ERROR"):
  time.sleep(.5)
  sys.stdout.write( "\r%02d%% Complete. Bytes %10d/%d. Files %d/%d" % (
      session.pctComplete(), 
      session.bytesTransferred, session.totalBytes,
      len(session.filesComplete), totalFiles 
    )
  )

  if len(session.filesComplete) == totalFiles:
    session.closePersistentSession()

  sys.stdout.flush()


print ""

if session.status() == "DONE":
  print "File Transfer Successful"
else:
  print "Transfer Failed"
  print "\n".join(session.errs)

print "Exiting..."
