cat << __README_START__ > README
pyFaspMgmt is a pure python implementation of the FASP management interface. 
  Written by Charles Shiflett (c) Aspera 2015-16

To install copy the entire pyFaspMgmt directory to the python application
you want to integrate pyFaspMgmt with and then "import pyfaspmgmt". 

__README_START__
pydoc pyfaspmgmt >> README 
cat << __README_END__ >> README
Configuration & Logging:

When you import pyfaspmgmt a configuration and log file are automatically
created in your current directory. You can control where pyfaspmgmt looks
for the pyfaspmgmt configuration file by editing configPaths in conf.py.

A typical faspmgmt.conf file:

  [all]
  sysid = Y1PyC5Rb-k30fVQ
  installpath = /path/to/pyfaspmgmt
  ascppath = /usr/bin/ascp
  sessionno = 30
  now = 1428135456
  currentpid = 26075

faspmgmt.conf must be writable as the configuration file is used to
ensure that each session identifier is unique. The values defined in the
config must be:

  sysid = <A string unique to each conf file>
  installpath = <path to write log files>
  ascppath = <path to ascp binary>
  sessionno = <a number, auto incremented and unique to each python instance>
  now = <a number, seconds since epoch in UTC>
  currentpid = <a number>

The logging subsytem uses python's standard logging and by default logs are
rotated every 10MB and a maximum of 5 logs are kept. In normal operation very
little should be logged, however it is a good place to check if you are
encountering errors.

If you find that the verbosity of the logs is not sufficient to debug problems
you encountered then enable debugging by setting:

  debug = true

In the configuration file. This will log almost everything the program does
and is a good way to determine where a problem lies. The most important thing
to look at when debugging is how ASCP is being called (just grep for ascp),
then make sure that command works as expected outside of your application.



Support:

For general support contact support@asperasoft.com. If you need help with
or would like to add a feature to pyFaspMgmt you can contact the Author at
bear@asperasoft.com or bear@us.ibm.com. Comments/Suggestions are welcome
as well.

Thank you for using Aspera!

__README_END__
